Name:           stage
Version:        3.2.2
Release:        8%{?dist}
Summary:        A 2.5D multi-robot simulator

Group:          Applications/Engineering
License:        GPLv2+
URL:            http://playerstage.sourceforge.net
Source0:        http://downloads.sourceforge.net/playerstage/Stage-%{version}-Source.tar.gz
# Fixes install path for cmake on 64 bit systems, and removes -O2 flag.  http://sourceforge.net/tracker/?func=detail&aid=2934664&group_id=42445&atid=433166
Patch0:         stage-3.2.2.fixcmake64.patch
# Fixes search path for included plugin libraries, which were moved to /usr/lib/stage.  Included in above patch submission.
# Proposed at http://old.nabble.com/Proposal%3A-Plugin-locations-for-Player-and-Stage-ts26868070.html 
Patch1:         stage-3.2.2.fixlibload.patch
# Fixes installation of example worlds, submitted at https://sourceforge.net/tracker/?func=detail&aid=2871625&group_id=42445&atid=433166
Patch2:         stage-3.2.2.fixexamples.patch
# Fixes DSO linking problem for executable.
Patch3:         stage-3.2.2.fixdso.patch
# Fixes for consumequeue and client unsubscription, accepted upstream
Patch4:         stage-3.2.2.fixconsumequeue.patch
Patch5:         stage-3.2.2.fixunsubscribe.patch
Patch6:         stage-3.2.2.playernogui.patch

BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)

BuildRequires:  cmake
BuildRequires:  doxygen 
BuildRequires:  fltk-devel 
BuildRequires:  graphviz 
BuildRequires:  libjpeg-devel
BuildRequires:  libpng-devel 
BuildRequires:  libtool-ltdl-devel 
BuildRequires:  libXext-devel 
BuildRequires:  libX11-devel 
BuildRequires:  libGL-devel 
BuildRequires:  libGLU-devel 
BuildRequires:  player-devel >= 3.0.1

%description
Stage is a fast and scalable 2.5D multiple robot simulator from the Player 
project.  Stage can be used to simulate sensors and actuators in a 
low-fidelity bit-mapped environment.  Stage models can be controlled with
the Stage C API, or through the Player server via a Player plug-in library.

%package devel
Summary: Header files and libraries for Stage
Group: Development/Libraries
Requires: %{name} = %{version}-%{release}
Requires: fltk-devel 
Requires: libpng-devel 
Requires: libjpeg-devel 
Requires: libGL-devel 
Requires: libGLU-devel

%description devel
This package contains the header files and libraries
for Stage. If you want to develop programs using the libstage
API, you will need to install stage-devel.

%package playerplugin
Summary: Plug-in to add Stage support to Player
Group: Development/Libraries
Requires: %{name} = %{version}-%{release}
Requires: player >= 3.0.1

%description playerplugin
This package contains the Stage plug-in library for the Player server.
stage-playerplugin allows Stage models to be exposed as Player interfaces,
and manipulated through the Player server.

%prep
%setup -q -n Stage-%{version}-Source
%patch0 -p1 
%patch1 -p1 
%patch2 -p1 
%patch3 -p1 
%patch4 -p0
%patch5 -p0
%patch6 -p0


%build
%cmake .

# Parallel build causes strange errors
make 

# Documentation builds separately
pushd docsrc
make
mv stage html
popd

%install
rm -rf $RPM_BUILD_ROOT
make install DESTDIR=$RPM_BUILD_ROOT
chmod +x $RPM_BUILD_ROOT%{_datadir}/stage/worlds/*.sh

# These config files are broken, remove them
rm $RPM_BUILD_ROOT%{_datadir}/stage/worlds/uoa*
rm $RPM_BUILD_ROOT%{_datadir}/stage/worlds/large.world
rm $RPM_BUILD_ROOT%{_datadir}/stage/worlds/asr.*
rm -rf $RPM_BUILD_ROOT%{_datadir}/stage/worlds/wifi*


%clean
rm -rf $RPM_BUILD_ROOT

%post -p /sbin/ldconfig

%postun -p /sbin/ldconfig

%files
%defattr(-,root,root,-)
%doc COPYING.txt DESCRIPTION.txt README.txt RELEASE.txt AUTHORS.txt
%{_bindir}/stage
%{_libdir}/*.so.*
%{_datadir}/stage
%{_libdir}/stage

%files playerplugin
%defattr(-,root,root,-)
%{_libdir}/player/*.so

%files devel
%defattr(-,root,root,-)
%doc docsrc/html
%{_libdir}/*.so
%{_libdir}/pkgconfig/*.pc
%{_includedir}/Stage-3.2


%changelog
* Sun Jan 23 2011 Rich Mattes <richmattes@gmail.com> - 3.2.2-8
- Fix multiple subscription/unsubscription crashes
- Allow stageplugin to be run without gui

* Sun Mar 14 2010 Rich Mattes <richmattes@gmail.com> - 3.2.2-7
- Merged -doc subpackage into -devel
- Added Requires pkgconfig entries

* Wed Mar 10 2010 Rich Mattes <richmattes@gmail.com> - 3.2.2-6
- Remove conflicting compiler flags

* Tue Mar 9 2010 Rich Mattes <richmattes@gmail.com> - 3.2.2-5
- Remove broken world files

* Sun Feb 28 2010 Rich Mattes <richmattes@gmail.com> - 3.2.2-4
- Fixed DSO link errors for F13
- Added necessary requires for -devel package
- Corrected Sourceforge download link

* Thu Feb 4 2010 Rich Mattes <richmattes@gmail.com> - 3.2.2-3
- More specfile cleanup

* Mon Jan 18 2010 Rich Mattes <richmattes@gmail.com> - 3.2.2-2
- Spec file cleanup
- License fixed

* Wed Sep 23 2009 Rich Mattes <richmattes@gmail.com> - 3.2.2-1
- First build
